From 32f372b0a59f5fdab8838e139b08f17514c4bee7 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jan 27 2017 15:30:02 +0000
Subject: [PATCH 673/1001] Add a way for plugins to register their own routes


---

diff --git a/hubs/app.py b/hubs/app.py
index a2a48a4..1990f58 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -797,3 +797,25 @@ def plus_plus_update(user):
         return flask.jsonify(req.json())
     else:
         return req.text, req.status_code
+
+
+#
+# Add widget-specific routes
+#
+
+def widget_view_decorator(func):
+    @functools.wraps(func)
+    def inner(*args, **kwargs):
+        hubname = kwargs.pop("hub")
+        widgetidx = kwargs.pop("idx")
+        widget = get_widget(session, hubname, widgetidx)
+        return func(session, widget, *args, **kwargs)
+    return inner
+
+for widget in session.query(hubs.models.Widget):
+    for params in getattr(widget.module, 'ROUTES', []):
+        params["rule"] = "/<hub>/<int:idx>/widget/" \
+                         + params["rule"].lstrip("/")
+        params["endpoint"] = "%s_%s" % (widget.plugin, params["endpoint"])
+        params["view_func"] = widget_view_decorator(params["view_func"])
+        app.add_url_rule(**params)

